DECLARE FUNCTION LenStr% (t$)
DECLARE SUB PrintStr (BYVAL x%, BYVAL y%, t$)
DECLARE SUB ClearNext (BYVAL Player%)
DECLARE SUB Frame (BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%)
DECLARE SUB ShowName (BYVAL Player%, BYVAL Place%, BYVAL Sel%)
DECLARE SUB ShowJewel (BYVAL Player%, BYVAL x%, BYVAL y%, BYVAL n%)
DEFINT A-Z
'$INCLUDE: 'columns.bi'
  
DIM SHARED blk(33, 11)
DIM SHARED no(21, 9)
DIM SHARED alpha(1381), alindex(38)
DIM SHARED difImg(34, 3)
DIM SHARED PBack(200, 1), ABack(54, 2, 1)
DIM SHARED TBack(2, 1) AS STRING * 1, TPos(2, 1)
DIM SHARED Page(1)
DIM SHARED temp(511)

SUB ClearNext (BYVAL Player)
  FOR i = 0 TO 2
    PUT (190 - 76 * Player, 4 + i * 16), blk(0, 0), PSET
  NEXT i
END SUB

SUB ClGOverMes (BYVAL Player)
  FOR y = 7 TO 5 STEP -1
    FOR x = 1 TO 4
      ShowJewel Player, x, y, 0
    NEXT x
  NEXT y
END SUB

SUB ClShowHigh (BYVAL Player)
  IF Page(Player) THEN
    FOR y = 9 TO 2 STEP -1
      FOR x = 0 TO 5
        ShowJewel Player, x, y, 0
      NEXT x
    NEXT y
    Page(Player) = 0
  END IF
END SUB

SUB DrawBoard ()

  Frame 0, 0, 103, 199
  Frame 216, 0, 319, 199
  FOR y = 11 TO 0 STEP -1
    FOR i = 0 TO 1
      FOR x = 0 TO 5
        ShowJewel i, x, y, 0
      NEXT x
    NEXT i
  NEXT y

  Frame 186, 0, 209, 55
  Frame 110, 0, 133, 55

  Frame 110, 62, 209, 112
  PrintStr 130, 78, "SCORE"

  Frame 110, 116, 209, 136
  PrintStr 130, 117, "LEVEL"

  Frame 110, 140, 209, 160
  PrintStr 139, 141, "DIFF"

  Frame 110, 164, 209, 199
  PrintStr 125, 165, "JEWELS"

  DEF SEG = VARSEG(temp(0))
  BLOAD "next_c.grp", VARPTR(temp(0))
  PUT (153, 5), temp(0)
  DEF SEG
  ClearNext 0: ClearNext 1
END SUB

SUB Frame (BYVAL x1, BYVAL y1, BYVAL x2, BYVAL y2)
  LINE (x1, y1)-(x2, y2), 1, B
  LINE (x1 + 1, y1 + 1)-(x2 - 1, y2 - 1), 2, B
  LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), 1, B
END SUB

SUB GameOverMessage (BYVAL Player)
  FOR y = 8 TO 3 STEP -1
    FOR x = 1 TO 4
      ShowJewel Player, x, y, 0
    NEXT x
  NEXT y
  FOR i = 0 TO 2
    TBack(i, Player) = CHR$(0)
  NEXT i
  PrintStr 241 - 216 * Player, 80, "GAME"
  PrintStr 243 - 216 * Player, 100, "OVER"
  PBack(0, Player) = 0
END SUB

SUB GrEnd ()
  SCREEN 0
  COLOR 7, 0
  WIDTH 80
END SUB

SUB GrInit ()
  DEF SEG = VARSEG(blk(0, 0))
  BLOAD "block_c.grp", VARPTR(blk(0, 0))
  DEF SEG = VARSEG(no(0, 0))
  BLOAD "number_c.grp", VARPTR(no(0, 0))
  DEF SEG = VARSEG(alpha(0))
  BLOAD "alpha_c.grp", VARPTR(alpha(0))
  FOR i = 0 TO 37
    alindex(i + 1) = alindex(i) + (5 + ((alpha(alindex(i)) + 7) \ 8) * alpha(alindex(i) + 1)) \ 2
  NEXT i
  DEF SEG = VARSEG(difImg(0, 0))
  BLOAD "diff_c.grp", VARPTR(difImg(0, 0))
  DEF SEG
  SCREEN 1
  ON ERROR RESUME NEXT
  PALETTE 1, 8
  PALETTE 2, 7
  PALETTE 3, 15
  ON ERROR GOTO 0

END SUB

SUB HighMessage (BYVAL Player)
  PrintStr 244 - 216 * Player, 60, "HIGH"
  PrintStr 238 - 216 * Player, 80, "SCORE"
  a$ = LTRIM$(RTRIM$(STR$(Game(Player).Place)))
  SELECT CASE Game(Player).Place
    CASE 1: a$ = a$ + "ST"
    CASE 2: a$ = a$ + "ND"
    CASE 3: a$ = a$ + "RD"
    CASE ELSE: a$ = a$ + "TH"
  END SELECT
  IF PBack(0, Player) THEN PUT (268 - Player * 216 - PBack(0, Player) \ 4, 95), PBack(0, Player), PSET
  xlen = LenStr(a$)
  x = 268 - Player * 216 - LenStr(a$) \ 2
  GET (x, 95)-STEP(xlen - 1, 19), PBack(0, Player)
  PrintStr x, 100, a$
  FOR i = 1 TO 3
    ShowName Player, i, (Game(Player).PlaceStatus AND 3) = i
  NEXT i
END SUB

FUNCTION LenStr (t$)
  FOR i = 1 TO LEN(t$)
    x = x + alpha(alindex(INSTR(NameStr, MID$(t$, i, 1)) - 1)) \ 2
  NEXT i
  LenStr = x
END FUNCTION

SUB OutMessage (BYVAL Player)
  FOR y = 5 TO 8
    FOR x = 1 TO 4
      ShowJewel Player, x, y, 0
    NEXT x
  NEXT y
  COLOR 7, 0
  LOCATE 8, 62 - Player * 53: PRINT "You're below";
  LOCATE 9, 64 - Player * 53: PRINT "10th now";
END SUB

SUB PrintDiff (BYVAL Player)
  PUT (186 - Player * 72, 144), difImg(0, Game(Player).Diff), PSET
END SUB

SUB PrintJewels (BYVAL Player)
  a& = Game(Player).Jewels
  IF a& = 0 THEN LINE (174 - 49 * Player, 183)-STEP(20, 12), 0, BF
  IF Player = 0 THEN
    DO
      PUT (196 - 11 * i, 183), no(0, a& MOD 10), PSET
      a& = a& \ 10
      i = i + 1
    LOOP WHILE a&
  ELSE
    b& = a&
    DO
      b& = b& \ 10
      i = i + 1
    LOOP WHILE b&
    FOR j = i TO 1 STEP -1
      b& = a&
        FOR k = 2 TO j
          b& = b& \ 10
        NEXT k
      PUT (114 + 11 * (i - j), 183), no(0, b& MOD 10), PSET
    NEXT j
  END IF
END SUB

SUB PrintLv (BYVAL Player)
  PUT (196 - 82 * Player - 11 * (LEN(a$) - i), 120), no(0, Game(Player).CurLv), PSET
END SUB

SUB PrintScore (BYVAL Player)
  a& = Game(Player).Score
  IF a& = 0 THEN LINE (141 - 16 * Player, 96 - 30 * Player)-STEP(53, 12), 0, BF
  IF Player = 0 THEN
    DO
      PUT (196 - 11 * i, 96), no(0, a& MOD 10), PSET
      a& = a& \ 10
      i = i + 1
    LOOP WHILE a&
  ELSE
    b& = a&
    DO
      b& = b& \ 10
      i = i + 1
    LOOP WHILE b&
    FOR j = i - 1 TO 0 STEP -1
      b& = a&
        FOR k = 1 TO j
          b& = b& \ 10
        NEXT k
      PUT (103 + 11 * (i - j), 66), no(0, b& MOD 10), PSET
    NEXT j
  END IF
END SUB

SUB PrintStr (BYVAL x, BYVAL y, t$)
  FOR i = 1 TO LEN(t$)
    cpos = INSTR(NameStr, MID$(t$, i, 1)) - 1
    PUT (x, y), alpha(alindex(cpos)), OR
    x = x + alpha(alindex(cpos)) \ 2
  NEXT i
END SUB

SUB ShowHigh (BYVAL Player)
  IF Page(Player) THEN
    FOR y = 9 TO 2 STEP -1
      FOR x = 0 TO 5
        ShowJewel Player, x, y, 0
      NEXT x
    NEXT y
  END IF
  Page(Player) = (Page(Player) + 1) MOD 11
  IF Page(Player) THEN
    IF High.Ini(Page(Player), Game(Player).Diff) = STRING$(3, 0) THEN
      Page(Player) = 0
      EXIT SUB
    END IF
    a$ = LTRIM$(RTRIM$(STR$(Page(Player))))
    SELECT CASE Page(Player)
      CASE 1: a$ = a$ + "ST"
      CASE 2: a$ = a$ + "ND"
      CASE 3: a$ = a$ + "RD"
      CASE ELSE: a$ = a$ + "TH"
    END SELECT
    PrintStr 230 - 216 * Player, 40, a$
    PrintStr 260 - 216 * Player, 60, High.Ini(Page(Player), Game(Player).Diff)
    PrintStr 230 - 216 * Player, 80, "SCORE"
    PrintStr 256 - 216 * Player, 100, STR$(High.Score(Page(Player), Game(Player).Diff))
    PrintStr 230 - 216 * Player, 120, "JEWELS"
    PrintStr 256 - 216 * Player, 140, STR$(High.Jewels(Page(Player), Game(Player).Diff))
  END IF
END SUB

SUB ShowJewel (BYVAL Player, BYVAL x, BYVAL y, BYVAL n)
  PUT (220 - Player * 216 + 16 * x, 180 - 16 * y), blk(0, n), PSET
END SUB

SUB ShowName (BYVAL Player, BYVAL Place, BYVAL Sel)
  IF TBack(0, Player) <> CHR$(0) THEN
    xlen = LenStr(MID$(Game(Player).Ini, Place, 1))
    IF xlen = LenStr(TBack(Place - 1, Player)) THEN
      endP = Place
    ELSE
      endP = 3
    END IF
    FOR i = Place TO 3
      PUT (250 - 216 * Player + TPos(i - 1, Player), 120), ABack(0, i - 1, Player), PSET
    NEXT i
  ELSE
    endP = Place
  END IF
  FOR i = Place TO 3
    TBack(i - 1, Player) = MID$(Game(Player).Ini, i, 1)
    xlen = LenStr(TBack(i - 1, Player))
    GET (250 - 216 * Player + TPos(i - 1, Player), 120)-STEP(xlen - 1, 20), ABack(0, i - 1, Player)
    PrintStr 250 - 216 * Player + TPos(i - 1, Player), 120, TBack(i - 1, Player)
    IF i <> 3 THEN TPos(i, Player) = TPos(i - 1, Player) + xlen
    IF i = Place AND Sel THEN
      LINE (250 - 216 * Player + TPos(i - 1, Player), 140)-STEP(xlen - 1, 0), 2
    END IF
  NEXT i
END SUB

SUB ShowNext (BYVAL Player)
  FOR i = 2 TO 0 STEP -1
    PUT (190 - 76 * Player, 36 - i * 16), blk(0, Game(Player).NextJewel(i)), PSET
  NEXT i
END SUB

