DECLARE SUB GrInit2 ()
DECLARE FUNCTION LenStr% (t$)
DECLARE SUB PrintStr (BYVAL X%, BYVAL Y%, t$)
DECLARE SUB ClearNext (BYVAL Player%)
DECLARE SUB Frame (BYVAL X1%, BYVAL Y1%, BYVAL X2%, BYVAL Y2%)
DECLARE SUB ShowName (BYVAL Player%, BYVAL Place%, BYVAL Sel%)
DECLARE SUB ShowJewel (BYVAL Player%, BYVAL X%, BYVAL Y%, BYVAL n%)
DEFINT A-Z
'$INCLUDE: 'columns.bi'
'$INCLUDE: 'svgabc.bi'

TYPE blocks
  d(723, 11) AS INTEGER
END TYPE
DIM SHARED blk AS blocks

TYPE alphas
  d(21701) AS INTEGER
END TYPE
DIM SHARED alpha() AS alphas
DIM SHARED alindex(38)

TYPE numbers
  d(129, 9) AS INTEGER
END TYPE
DIM SHARED nos AS numbers

TYPE diffimg
  d(1385) AS INTEGER
END TYPE
DIM SHARED diffs(0) AS diffimg
DIM SHARED diffindex(38)

DIM SHARED PBack(2353, 1), ABack(793, 2, 1)
DIM SHARED TBack(2, 1) AS STRING * 1, TPos(2, 1)
DIM SHARED Page(1)

TYPE scrimg
  d(2355) AS INTEGER
END TYPE

SUB ClearNext (BYVAL Player)
  FOR i = 0 TO 2
	BLKPUT 1, 354 - Player * 106, 80 - 38 * i, blk.d(0, 0)
  NEXT i
END SUB

SUB ClGOverMes (BYVAL Player)
  FOR Y = 6 TO 4 STEP -1
	FOR X = 1 TO 4
	  ShowJewel Player, X, Y, 0
	NEXT X
  NEXT Y
END SUB

SUB ClShowHigh (BYVAL Player)
  IF Page(Player) THEN
	FOR Y = 10 TO 1 STEP -1
	  FOR X = 0 TO 5
		ShowJewel Player, X, Y, 0
	  NEXT X
	NEXT Y
  END IF
  Page(Player) = 0
END SUB

SUB DrawBoard ()

  Frame 0, 0, 235, 463
  Frame 404, 0, 639, 463
  FOR Y = 11 TO 0 STEP -1
	FOR i = 0 TO 1
	  FOR X = 0 TO 5
		ShowJewel i, X, Y, 0
	  NEXT X
	NEXT i
  NEXT Y

  Frame 350, 0, 395, 121
  Frame 244, 0, 290, 121
  PrintStr 296, 1, "N"
  PrintStr 322, 25, "E"
  PrintStr 296, 49, "X"
  PrintStr 322, 73, "T"
  ClearNext 0: ClearNext 1

  DIM scrimgs(0) AS scrimg
  OPEN "sc.grp" FOR BINARY ACCESS READ AS #1
  GET #1, , scrimgs(0)
  CLOSE #1

  Frame 244, 143, 395, 217
  BLKPUT 1, 283, 172, scrimgs(0).d(0)

  Frame 244, 239, 395, 271
  BLKPUT 1, 287, 247, scrimgs(0).d(623)

  Frame 244, 293, 395, 367
  BLKPUT 1, 297, 322, scrimgs(0).d(1178)

  Frame 244, 389, 395, 463
  BLKPUT 1, 276, 418, scrimgs(0).d(1571)

END SUB

SUB Frame (BYVAL X1, BYVAL Y1, BYVAL X2, BYVAL Y2)
  DRWBOX 1, 17, X1, Y1, X2, Y2
  DRWBOX 1, 22, X1 + 1, Y1 + 1, X2 - 1, Y2 - 1
  DRWBOX 1, 17, X1 + 2, Y1 + 2, X2 - 2, Y2 - 2
END SUB

SUB GameOverMessage (BYVAL Player)
  FOR Y = 8 TO 3 STEP -1
	FOR X = 1 TO 4
	  ShowJewel Player, X, Y, 0
	NEXT X
  NEXT Y
  FOR i = 0 TO 2
	TBack(i, Player) = CHR$(0)
  NEXT i
  PrintStr 470 - Player * 404, 192, "GAME"
  PrintStr 472 - Player * 404, 240, "OVER"
  PBack(0, Player) = 0
END SUB

SUB GrEnd ()
  dummy = RESTEXT
END SUB

SUB GrInit ()

  IF WHICHCPU < 386 THEN END
  IF WHICHVGA = 0 THEN END
  IF WHICHMEM < 512 THEN END

  OPEN "blocks.grp" FOR BINARY ACCESS READ AS #1
  GET #1, , blk
  CLOSE #1

  REDIM alpha(0) AS alphas
  OPEN "alpha.grp" FOR BINARY ACCESS READ AS #1
  GET #1, , alpha(0)
  CLOSE #1
  FOR i = 0 TO 37
	alindex(i + 1) = alindex(i) + 2 + ((alpha(0).d(alindex(i)) + 1) * (alpha(0).d(alindex(i) + 1) + 1) + 1) \ 2
  NEXT i

  OPEN "numbers.grp" FOR BINARY ACCESS READ AS #1
  GET #1, , nos
  CLOSE #1

  OPEN "diffs.grp" FOR BINARY ACCESS READ AS #1
  GET #1, , diffs(0)
  CLOSE #1
  FOR i = 0 TO 3
	diffindex(i + 1) = diffindex(i) + 2 + ((diffs(0).d(diffindex(i)) + 1) * (diffs(0).d(diffindex(i) + 1) + 1) + 1) \ 2
  NEXT i

  DIM Pal AS STRING * 768
  OPEN "colsvga.pal" FOR BINARY ACCESS READ AS #1
  GET #1, , Pal
  CLOSE #1

  IF RES640 = 0 THEN END
  PALSET Pal, 0, 255

END SUB

SUB HighMessage (BYVAL Player)
  PrintStr 478 - 404 * Player, 120, "HIGH"
  PrintStr 459 - 404 * Player, 168, "SCORE"
  a$ = LTRIM$(RTRIM$(STR$(Game(Player).Place)))
  SELECT CASE Game(Player).Place
	CASE 1: a$ = a$ + "ST"
	CASE 2: a$ = a$ + "ND"
	CASE 3: a$ = a$ + "RD"
	CASE ELSE: a$ = a$ + "TH"
  END SELECT
  IF PBack(0, Player) THEN BLKPUT 1, 522 - Player * 404 - (PBack(0, Player) + 1) \ 2, 216, PBack(0, Player)
  xlen = LenStr(a$)
  X = 522 - Player * 404 - LenStr(a$) \ 2
  BLKGET X, 216, X + xlen - 1, 263, PBack(0, Player)
  PrintStr X, 216, a$
  FOR i = 1 TO 3
	ShowName Player, i, (Game(Player).PlaceStatus AND 3) = i
  NEXT i
END SUB

FUNCTION LenStr (t$)
  FOR i = 1 TO LEN(t$)
	X = X + alpha(0).d(alindex(INSTR(NameStr, MID$(t$, i, 1)) - 1)) + 1
  NEXT i
  LenStr = X
END FUNCTION

SUB OutMessage (BYVAL Player)
  FOR Y = 8 TO 3 STEP -1
	FOR X = 1 TO 4
	  ShowJewel Player, X, Y, 0
	NEXT X
  NEXT Y
  FOR i = 0 TO 2
	TBack(i, Player) = CHR$(0)
  NEXT i
  PBack(0, Player) = 0
END SUB

SUB PrintDiff (BYVAL Player)
  a = Game(Player).Diff
  l = diffs(0).d(diffindex(a)) + 1
  X = 345 - 93 * Player
  Y = 343 - 42 * Player
  IF l < 43 THEN
	IF l < 42 THEN
	  DRWFILLBOX 1, 0, X, Y, X + (41 - l) \ 2, Y + 16
	END IF
	DRWFILLBOX 1, 0, X + (43 + l) \ 2, Y, X + 42, Y + 16
	X = X + (43 - l) \ 2
  END IF
  BLKPUT 1, X, Y, diffs(0).d(diffindex(a))
END SUB

SUB PrintJewels (BYVAL Player)

  a& = Game(Player).Jewels
  IF a& = 0 THEN
	X = 341 - 73 * Player
	Y = 439 - 42 * Player
	DRWFILLBOX 1, 0, X, Y, X + 30, Y + 16
  END IF
  IF Player = 0 THEN
	DO
	  BLKPUT 1, 373 - 16 * i, 439, nos.d(0, a& MOD 10)
	  a& = a& \ 10
	  i = i + 1
	LOOP WHILE a&
  ELSE
	b& = a&
	DO
	  b& = b& \ 10
	  i = i + 1
	LOOP WHILE b&
	FOR j = i - 1 TO 0 STEP -1
	  b& = a&
		FOR k = 1 TO j
		  b& = b& \ 10
		NEXT k
	  BLKPUT 1, 236 + 16 * (i - j), 397, nos.d(0, b& MOD 10)
	NEXT j
  END IF

END SUB

SUB PrintLv (BYVAL Player)
  a = Game(Player).CurLv
  BLKPUT 1, 373 - 121 * Player, 247, nos.d(0, a)
END SUB

SUB PrintScore (BYVAL Player)

  a& = Game(Player).Score
  IF a& = 0 THEN
	X = 293 - 25 * Player
	Y = 193 - 42 * Player
	DRWFILLBOX 1, 0, X, Y, X + 78, Y + 16
  END IF
  IF Player = 0 THEN
	DO
	  BLKPUT 1, 373 - 16 * i, 193, nos.d(0, a& MOD 10)
	  a& = a& \ 10
	  i = i + 1
	LOOP WHILE a&
  ELSE
	b& = a&
	DO
	  b& = b& \ 10
	  i = i + 1
	LOOP WHILE b&
	FOR j = i - 1 TO 0 STEP -1
	  b& = a&
		FOR k = 1 TO j
		  b& = b& \ 10
		NEXT k
	  BLKPUT 1, 236 + 16 * (i - j), 151, nos.d(0, b& MOD 10)
	NEXT j
  END IF

END SUB

SUB PrintStr (BYVAL X, BYVAL Y, t$)
  FOR i = 1 TO LEN(t$)
	cpos = INSTR(NameStr, MID$(t$, i, 1)) - 1
	SPRITEPUT 1, 0, X, Y, alpha(0).d(alindex(cpos))
	X = X + alpha(0).d(alindex(cpos)) + 1
  NEXT i
END SUB

SUB ShowHigh (BYVAL Player)

  IF Page(Player) THEN
	FOR Y = 10 TO 1 STEP -1
	  FOR X = 0 TO 5
		ShowJewel Player, X, Y, 0
	  NEXT X
	NEXT Y
  END IF

  Page(Player) = (Page(Player) + 1) MOD 11
  IF Page(Player) THEN
	IF High.Ini(Page(Player), Game(Player).Diff) = STRING$(3, 0) THEN
	  Page(Player) = 0
	  EXIT SUB
	END IF

	a$ = LTRIM$(RTRIM$(STR$(Page(Player))))
	SELECT CASE Page(Player)
	  CASE 1: a$ = a$ + "ST"
	  CASE 2: a$ = a$ + "ND"
	  CASE 3: a$ = a$ + "RD"
	  CASE ELSE: a$ = a$ + "TH"
	END SELECT

	PrintStr 430 - 404 * Player, 72, a$
	a$ = High.Ini(Page(Player), Game(Player).Diff)
	X = 613 - LenStr(a$) - 404 * Player
	PrintStr X, 120, High.Ini(Page(Player), Game(Player).Diff)

	PrintStr 430 - 404 * Player, 184, "SCORE"
	a$ = LTRIM$(RTRIM$(STR$(High.Score(Page(Player), Game(Player).Diff))))
	X = 613 - LenStr(a$) - 404 * Player
	PrintStr X, 232, a$

	PrintStr 430 - 404 * Player, 296, "JEWELS"
	a$ = LTRIM$(RTRIM$(STR$(High.Jewels(Page(Player), Game(Player).Diff))))
	X = 613 - LenStr(a$) - 404 * Player
	PrintStr X, 344, a$

  END IF
END SUB

SUB ShowJewel (BYVAL Player, BYVAL X, BYVAL Y, BYVAL n)
  BLKPUT 1, 408 - Player * 404 + 38 * X, 422 - 38 * Y, blk.d(0, n)
END SUB

SUB ShowName (BYVAL Player, BYVAL Place, BYVAL Sel)
  IF TBack(0, Player) <> CHR$(0) THEN
	xlen = LenStr(MID$(Game(Player).Ini, Place, 1))
	IF xlen = LenStr(TBack(Place - 1, Player)) THEN
	  endP = Place
	ELSE
	  endP = 3
	END IF
	FOR i = Place TO 3
	  BLKPUT 1, 484 - 404 * Player + TPos(i - 1, Player), 264, ABack(0, i - 1, Player)
	NEXT i
  ELSE
	endP = Place
  END IF
  FOR i = Place TO 3
	TBack(i - 1, Player) = MID$(Game(Player).Ini, i, 1)
	xlen = LenStr(TBack(i - 1, Player))
	X = 484 - 404 * Player + TPos(i - 1, Player)
	BLKGET X, 264, X + xlen - 1, 311, ABack(0, i - 1, Player)
	PrintStr X, 264, TBack(i - 1, Player)
	IF i <> 3 THEN TPos(i, Player) = TPos(i - 1, Player) + xlen
	IF i = Place AND Sel THEN
	  DRWBOX 1, 192, X, 310, X + xlen - 1, 311
	END IF
  NEXT i
END SUB

SUB ShowNext (BYVAL Player)
  FOR i = 0 TO 2
	BLKPUT 1, 354 - Player * 106, 80 - 38 * i, blk.d(0, Game(Player).NextJewel(i))
  NEXT i
END SUB

