DECLARE SUB GrInit ()
DECLARE SUB ShowName (BYVAL Player%, BYVAL Place%, BYVAL Sel%)
DECLARE SUB ShowJewel (BYVAL Player%, BYVAL x%, BYVAL y%, BYVAL n%)
DEFINT A-Z
'$INCLUDE: 'columns.bi'

SUB ClearNext (BYVAL Player)
  FOR i = 0 TO 5
    COLOR 0
    LOCATE 2 + i, 48 - Player * 18
    PRINT "";
  NEXT i
END SUB

SUB DrawBoard ()

  GrInit
  COLOR 7, 0
  FOR i = 1 TO 24
    LOCATE i, 1: PRINT "";
    LOCATE i, 26: PRINT "";
    LOCATE i, 55: PRINT "";
    LOCATE i, 80: PRINT "";
  NEXT i
  LOCATE 25, 1: PRINT STRING$(26, 223);
  LOCATE 25, 55: PRINT STRING$(26, 223);

  LOCATE 1, 30: PRINT STRING$(5, 220);
  LOCATE 1, 48: PRINT STRING$(5, 220);
  FOR i = 2 TO 7
    LOCATE i, 29: PRINT "";
    LOCATE i, 34: PRINT "";
    LOCATE i, 47: PRINT "";
    LOCATE i, 52: PRINT "";
  NEXT i
  LOCATE 8, 29: PRINT STRING$(5, 223);
  LOCATE 8, 47: PRINT STRING$(5, 223);
  LOCATE 5, 37: PRINT CHR$(17) + " Next " + CHR$(16);

  LOCATE 9, 30: PRINT STRING$(10, 220);
  LOCATE 10, 29: PRINT "";
  LOCATE 10, 39: PRINT "";
  LOCATE 11, 29: PRINT STRING$(10, 223);
  LOCATE 13, 43: PRINT STRING$(10, 220);
  LOCATE 14, 42: PRINT "";
  LOCATE 14, 52: PRINT "";
  LOCATE 15, 42: PRINT STRING$(10, 223);
  LOCATE 12, 36: PRINT CHR$(17) + " Score  " + CHR$(16);

  LOCATE 16, 30: PRINT STRING$(4, 220);
  LOCATE 17, 29: PRINT "";
  LOCATE 17, 33: PRINT "";
  LOCATE 18, 29: PRINT STRING$(4, 223);
  LOCATE 16, 49: PRINT STRING$(4, 220);
  LOCATE 17, 48: PRINT "";
  LOCATE 17, 52: PRINT "";
  LOCATE 18, 48: PRINT STRING$(4, 223);
  LOCATE 17, 36: PRINT CHR$(17) + " Level  " + CHR$(16);

  LOCATE 19, 30: PRINT STRING$(6, 220);
  LOCATE 20, 29: PRINT "";
  LOCATE 20, 35: PRINT "";
  LOCATE 21, 29: PRINT STRING$(6, 223);
  LOCATE 19, 47: PRINT STRING$(6, 220);
  LOCATE 20, 46: PRINT "";
  LOCATE 20, 52: PRINT "";
  LOCATE 21, 46: PRINT STRING$(6, 223);
  LOCATE 20, 37: PRINT CHR$(17) + " Diff " + CHR$(16);

  LOCATE 22, 30: PRINT STRING$(7, 220);
  LOCATE 23, 29: PRINT "";
  LOCATE 23, 36: PRINT "";
  LOCATE 24, 29: PRINT STRING$(7, 223);
  LOCATE 22, 46: PRINT STRING$(7, 220);
  LOCATE 23, 45: PRINT "";
  LOCATE 23, 52: PRINT "";
  LOCATE 24, 45: PRINT STRING$(7, 223);
  LOCATE 23, 37: PRINT CHR$(17) + "Jewels" + CHR$(16);

END SUB

SUB GameOverMessage (BYVAL Player)
  COLOR 7, 0
  LOCATE 8, 63 - Player * 54: PRINT "Game  Over";
END SUB

SUB GrEnd ()
END SUB

SUB GrInit ()
END SUB

SUB HighMessage (BYVAL Player)
  COLOR 7, 0
  LOCATE 8, 63 - Player * 54: PRINT "You're the";
  a$ = LTRIM$(RTRIM$(STR$(Game(Player).Place)))
  LOCATE 9, 66 - Player * 54: PRINT USING "\\"; a$;
  SELECT CASE Game(Player).Place
  CASE 1: PRINT "st";
  CASE 2: PRINT "nd";
  CASE 3: PRINT "rd";
  CASE ELSE: PRINT "th";
  END SELECT
  LOCATE 11, 63 - Player * 54: PRINT "Enter your";
  LOCATE 12, 66 - Player * 54: PRINT "name";
  FOR i = 1 TO 3
    ShowName Player, i, (Game(Player).PlaceStatus AND 3) = i
  NEXT i
END SUB

SUB OutMessage (BYVAL Player)
  FOR y = 5 TO 8
    FOR x = 1 TO 4
      ShowJewel Player, x, y, 0
    NEXT x
  NEXT y
  COLOR 7, 0
  LOCATE 8, 62 - Player * 53: PRINT "You're below";
  LOCATE 9, 64 - Player * 53: PRINT "10th now";
END SUB

SUB PrintDiff (BYVAL Player)
  LOCATE 20, 48 - 17 * Player
  COLOR 7, 0
  SELECT CASE Game(Player).Diff
    CASE 0: PRINT "Nov";
    CASE 1: PRINT "Mid";
    CASE 2: PRINT "Exp";
    CASE 3: PRINT "Pro";
  END SELECT
END SUB

SUB PrintJewels (BYVAL Player)
  a$ = LTRIM$(RTRIM$(STR$(Game(Player).Jewels)))
  IF LEN(a$) < 4 THEN a$ = SPACE$(4 - LEN(a$)) + a$
  IF Player = 0 THEN
    LOCATE 23, 51 - LEN(a$)
  ELSE
    LOCATE 23, 35 - LEN(a$)
  END IF
  COLOR 7, 0
  PRINT a$;
END SUB

SUB PrintLv (BYVAL Player)
  a$ = LTRIM$(RTRIM$(STR$(Game(Player).CurLv)))
  IF Player = 0 THEN
    LOCATE 17, 51 - LEN(a$)
  ELSE
    LOCATE 17, 32 - LEN(a$)
  END IF
  COLOR 7, 0
  PRINT a$;
END SUB

SUB PrintScore (BYVAL Player)
  a$ = LTRIM$(RTRIM$(STR$(Game(Player).Score)))
  IF LEN(a$) < 7 THEN a$ = SPACE$(7 - LEN(a$)) + a$
  IF Player = 0 THEN
    LOCATE 14, 51 - LEN(a$)
  ELSE
    LOCATE 10, 38 - LEN(a$)
  END IF
  COLOR 7, 0
  PRINT a$;
END SUB

SUB ShowJewel (BYVAL Player, BYVAL x, BYVAL y, BYVAL n)
  COLOR n - 1 * (n > 0) - 7 * (n <= 7 AND n > 0)
  LOCATE 23 - 2 * y, 56 + 4 * x - Player * 54
  PRINT "";
  LOCATE 24 - 2 * y, 56 + 4 * x - Player * 54
  IF n <= 7 AND n > 0 THEN PRINT USING "#"; n;  ELSE PRINT "";
END SUB

SUB ShowName (BYVAL Player, BYVAL Place, BYVAL Sel)
  IF Sel THEN COLOR 15, 0 ELSE COLOR 7, 0
  LOCATE 14, 65 + Place - Player * 54
  PRINT MID$(Game(Player).Ini, Place, 1);
END SUB

SUB ShowNext (BYVAL Player)

  FOR i = 0 TO 2
    COLOR Game(Player).NextJewel(i) + 8
    LOCATE 6 - 2 * i, 48 - Player * 18
    PRINT "";
    LOCATE 7 - 2 * i, 48 - Player * 18
    PRINT USING "#"; Game(Player).NextJewel(i);
  NEXT i
  
END SUB

