DECLARE SUB ClShowHigh (BYVAL CurP%)
DECLARE SUB ShowHigh (BYVAL Player%)
DECLARE SUB ClGOverMes (BYVAL Player%)
DECLARE SUB CGOverMes (BYVAL Player%)
DECLARE SUB GrEnd ()
DECLARE SUB GrInit ()
DECLARE SUB ClearBuf (BYVAL Player%)
DECLARE SUB ClearPlayer (BYVAL Player%)
DECLARE SUB CountDemand (BYVAL Player%, BYVAL x%, BYVAL y%, Demand%())
DECLARE SUB GenJewel (BYVAL Player%)
DECLARE SUB Init ()
DECLARE SUB Main ()
DECLARE FUNCTION MvDown% (BYVAL Player%)
DECLARE FUNCTION MvDrop% (BYVAL Player%)
DECLARE SUB MvLeft (BYVAL Player%)
DECLARE SUB MvRight (BYVAL Player%)
DECLARE SUB NameDown (BYVAL Player%)
DECLARE SUB NameLeft (BYVAL Player%)
DECLARE SUB NameRight (BYVAL Player%)
DECLARE SUB NameUp (BYVAL Player%)
DECLARE SUB NewRecord (Diff%, Ini AS STRING, Score AS LONG, Jewels AS LONG)
DECLARE SUB ReadTop ()
DECLARE SUB RotateJewel (BYVAL Player%)
DECLARE SUB ShowNext (BYVAL Player%)
DECLARE SUB UpDateTop ()
DECLARE SUB DrawBoard ()
DECLARE SUB PrintDiff (BYVAL Player%)
DECLARE SUB PrintJewels (BYVAL Player%)
DECLARE SUB PrintLv (BYVAL Player%)
DECLARE SUB PrintScore (BYVAL Player%)
DECLARE SUB ShowJewel (BYVAL Player%, BYVAL x%, BYVAL y%, BYVAL n%)
DECLARE SUB HighMessage (BYVAL Player%)
DECLARE SUB OutMessage (BYVAL Player%)
DECLARE SUB ClearNext (BYVAL Player%)
DECLARE SUB ShowName (BYVAL Player%, BYVAL Place%, BYVAL Sel%)
DECLARE SUB GameOverMessage (BYVAL Player%)
DECLARE FUNCTION LenStr% (t$)

DEFINT A-Z

CONST Selecting = 0
CONST Moving = 1
CONST Eating = 2
CONST Eating2 = 3
CONST Marking = 4
CONST Clearing = 5
CONST Sinking = 6
CONST GameOver = 7
CONST HighMsg = 8
CONST EnterName = 9
CONST OutMsg = 10      'Place go down to below to when entering name
CONST GameOverMsg = 11
CONST ResetDelay = 12

'$INCLUDE: 'columns.bi'

REDIM SHARED Game(1) AS GameData
'DIM SHARED High AS Top10
DIM SHARED Times(9)

DEF SEG = &H40
KeyState = PEEK(23) AND 240
POKE 23, 0
DEF SEG

CLS

GrInit
DrawBoard
ReadTop
Init
Main
FOR i = 0 TO 1
  SELECT CASE Game(i).PlaceStatus AND 24
    CASE 0: NewRecord Game(i).Diff, "   ", Game(i).Score, Game(i).Jewels
    CASE 8: NewRecord Game(i).Diff, Game(i).Ini, Game(i).Score, Game(i).Jewels
  END SELECT
NEXT i
UpDateTop
GrEnd
COLOR 7, 0
CLS

DEF SEG = &H40
POKE 23, KeyState
DEF SEG

END

P1LeftKey:
  Game(0).LeftKey = NOT Game(0).LeftKey
  IF Game(0).LeftKey THEN
    KEY 15, CHR$(0) + CHR$(203)   'Left Key Release (75 + 128)
    Game(0).LeftKeyBuf = Game(0).LeftKeyBuf + 1
  ELSE
    KEY 15, CHR$(0) + CHR$(75)
  END IF
  RETURN

P1RightKey:
  Game(0).RightKey = NOT Game(0).RightKey
  IF Game(0).RightKey THEN
    KEY 16, CHR$(0) + CHR$(205)   'Right Key Release
    Game(0).RightKeyBuf = Game(0).RightKeyBuf + 1
  ELSE
    KEY 16, CHR$(0) + CHR$(77)
  END IF
  RETURN

P1Rotate:
  Game(0).Rotate = NOT Game(0).Rotate
  IF Game(0).Rotate THEN
    KEY 17, CHR$(0) + CHR$(204)
    Game(0).RotateBuf = Game(0).RotateBuf + 1
  ELSE
    KEY 17, CHR$(0) + CHR$(76)
  END IF
  RETURN

P1Drop:
  Game(0).Drop = NOT Game(0).Drop
  IF Game(0).Drop THEN
    KEY 18, CHR$(0) + CHR$(208)
    Game(0).DropBuf = Game(0).DropBuf + 1
  ELSE
    KEY 18, CHR$(0) + CHR$(80)
  END IF
  RETURN

P2LeftKey:
  Game(1).LeftKey = NOT Game(1).LeftKey
  IF Game(1).LeftKey THEN
    KEY 19, CHR$(0) + CHR$(158)   'Left Key Release (75 + 128)
    Game(1).LeftKeyBuf = Game(1).LeftKeyBuf + 1
  ELSE
    KEY 19, CHR$(0) + CHR$(30)
  END IF
  RETURN

P2RightKey:
  Game(1).RightKey = NOT Game(1).RightKey
  IF Game(1).RightKey THEN
    KEY 20, CHR$(0) + CHR$(160)   'Right Key Release
    Game(1).RightKeyBuf = Game(1).RightKeyBuf + 1
  ELSE
    KEY 20, CHR$(0) + CHR$(32)
  END IF
  RETURN

P2Rotate:
  Game(1).Rotate = NOT Game(1).Rotate
  IF Game(1).Rotate THEN
    KEY 21, CHR$(0) + CHR$(159)
    Game(1).RotateBuf = Game(1).RotateBuf + 1
  ELSE
    KEY 21, CHR$(0) + CHR$(31)
  END IF
  RETURN

P2Drop:
  Game(1).Drop = NOT Game(1).Drop
  IF Game(1).Drop THEN
    KEY 22, CHR$(0) + CHR$(173)
    Game(1).DropBuf = Game(1).DropBuf + 1
  ELSE
    KEY 22, CHR$(0) + CHR$(45)
  END IF
  RETURN

DATA 36,30,24,19,14,9,6,4,2,1

SUB ClearBuf (BYVAL Player)
  Game(Player).LeftKeyBuf = 0
  Game(Player).RightKeyBuf = 0
  Game(Player).RotateBuf = 0
  Game(Player).DropBuf = 0
END SUB

SUB ClearPlayer (BYVAL Player)

  FOR x = 0 TO 5
    FOR y = 0 TO 14
      Game(Player).Board(x, y) = 0
    NEXT y
    Game(Player).Top(x) = 0
  NEXT x

  Game(Player).Jewels = 0
  Game(Player).TilesPlayed = 0
  Game(Player).CurLv = Game(Player).Lv
  Game(Player).Score = 0
  Game(Player).Chains = 1
  Game(Player).Place = 0
  Game(Player).PlaceStatus = 0
  Game(1 - Player).PlaceStatus = Game(1 - Player).PlaceStatus AND &HFFFB

  PrintScore Player
  PrintLv Player
  PrintDiff Player
  PrintJewels Player

END SUB

SUB CountDemand (BYVAL Player, BYVAL x, BYVAL y, Demand())
  DIM DemOn(1 TO 6)
  FOR i = 0 TO 3
    SELECT CASE i
      CASE 0: xInc = 0: yInc = 1
      CASE 1: xInc = 1: yInc = 1
      CASE 2: xInc = 1: yInc = 0
      CASE 3: xInc = 1: yInc = -1
    END SELECT
    IF x + xInc < 6 AND x + xInc >= 0 AND y >= -yInc THEN
      a = Game(Player).Board(x + xInc, y + yInc)
      IF a THEN
        IF NOT DemOn(a) AND x + 2 * xInc < 6 AND x + 2 * xInc >= 0 AND y >= -2 * yInc THEN
          IF a = Game(Player).Board(x + 2 * xInc, y + 2 * yInc) THEN
            Demand(a) = Demand(a) + 1
            DemOn(a) = True
          END IF
        END IF
        IF NOT DemOn(a) AND x - xInc < 6 AND x - xInc >= 0 AND y >= yInc THEN
          IF a = Game(Player).Board(x - xInc, y - yInc) THEN
            Demand(a) = Demand(a) + 1
            DemOn(a) = True
          END IF
        END IF
      END IF
    END IF
    IF x - 2 * xInc < 6 AND x - 2 * xInc >= 0 AND y > 2 * yInc THEN
      a = Game(Player).Board(x - xInc, y - yInc)
      IF a THEN
        IF NOT DemOn(a) THEN
          IF a = Game(Player).Board(x - 2 * xInc, y - 2 * yInc) THEN
            Demand(a) = Demand(a) + 1
            DemOn(a) = True
          END IF
        END IF
      END IF
    END IF
  NEXT i
END SUB

SUB GenJewel (BYVAL Player)

  DIM Demand(1 TO 6)   'Demand(i) > 0 means jewel i will not appear

  IF Game(Player).TilesPlayed MOD 100 = 99 THEN
    FOR i = 0 TO 2
      Game(Player).NextJewel(i) = 7
    NEXT i
  ELSE
    SELECT CASE Game(Player).Diff
      CASE 0
        FOR i = 0 TO 2
          Game(Player).NextJewel(i) = INT(RND * 4) + 1
        NEXT i
      CASE 1
        FOR i = 0 TO 2
          Game(Player).NextJewel(i) = INT(RND * 5) + 1
        NEXT i
      CASE 2
        FOR i = 0 TO 2
          Game(Player).NextJewel(i) = INT(RND * 6) + 1
        NEXT i
      CASE 3
        FOR x = 0 TO 5
          FOR y = Game(Player).Top(x) TO Game(Player).Top(x) + 2
            IF y <= 12 THEN CountDemand Player, x, y, Demand()
          NEXT y
        NEXT x

        Count = 0
        FOR i = 1 TO 6
          IF Demand(i) THEN Count = Count + 1
        NEXT i

        SELECT CASE RND
          CASE IS < .01
            Same = 3
          CASE IS < .1
            Same = 2
          CASE ELSE
            Same = 1
        END SELECT

        FOR i = 3 + Same TO Count
          DO
            a = INT(RND * 6 + 1)
          LOOP UNTIL Demand(a)
          Demand(a) = 0
        NEXT i

        FOR i = 0 TO 3 - Same
          DO
            a = INT(RND * 6 + 1)
          LOOP WHILE Demand(a)
          Game(Player).NextJewel(i) = a
          Demand(a) = 1
        NEXT i

        FOR i = 4 - Same TO 2
          Game(Player).NextJewel(i) = Game(Player).NextJewel(0)
        NEXT i

        IF Same = 2 THEN
          SELECT CASE INT(RND * 3)
            CASE 0
              SWAP Game(Player).NextJewel(0), Game(Player).NextJewel(1)
            CASE 1
              SWAP Game(Player).NextJewel(1), Game(Player).NextJewel(2)
          END SELECT
        END IF

    END SELECT
  END IF

  ShowNext (Player)
  Game(Player).TilesPlayed = Game(Player).TilesPlayed + 1
  Game(Player).NextOK = True

END SUB

SUB Init ()

  RANDOMIZE

  ClearPlayer (0)
  ClearPlayer (1)
  Game(0).Ini = "   "
  Game(1).Ini = "   "
  FOR i = 0 TO 9
    READ Times(i)
  NEXT i

  KEY 15, CHR$(0) + CHR$(75)
  ON KEY(15) GOSUB P1LeftKey
  KEY 16, CHR$(0) + CHR$(77)
  ON KEY(16) GOSUB P1RightKey
  KEY 17, CHR$(0) + CHR$(76)
  ON KEY(17) GOSUB P1Rotate
  KEY 18, CHR$(0) + CHR$(80)
  ON KEY(18) GOSUB P1Drop
  KEY 19, CHR$(0) + CHR$(30)
  ON KEY(19) GOSUB P2LeftKey
  KEY 20, CHR$(0) + CHR$(32)
  ON KEY(20) GOSUB P2RightKey
  KEY 21, CHR$(0) + CHR$(31)
  ON KEY(21) GOSUB P2Rotate
  KEY 22, CHR$(0) + CHR$(45)
  ON KEY(22) GOSUB P2Drop
  FOR i = 15 TO 22
    KEY(i) ON
  NEXT i

END SUB

SUB Main ()
  DO
    DO
      kbd$ = INKEY$
      IF kbd$ = CHR$(27) THEN Finished = True
    LOOP UNTIL kbd$ = ""
    IF TIMER <> OldTimer! THEN
      FOR i = 0 TO 1
        IF Game(i).TimeWait THEN Game(i).TimeWait = Game(i).TimeWait - 1
        IF Game(i).LeftKeyWait THEN Game(i).LeftKeyWait = Game(i).LeftKeyWait - 1
        IF Game(i).RightKeyWait THEN Game(i).RightKeyWait = Game(i).RightKeyWait - 1
        IF Game(i).RotateWait THEN Game(i).RotateWait = Game(i).RotateWait - 1
        IF Game(i).DropWait THEN Game(i).DropWait = Game(i).DropWait - 1
      NEXT i
      Tick = True
      OldTimer! = TIMER
    ELSE
      Tick = False
    END IF
    FOR CurP = 0 TO 1
      SELECT CASE Game(CurP).Action
        CASE Selecting
          IF Game(CurP).LeftKeyBuf THEN
            Game(CurP).Lv = (Game(CurP).Lv + 1) MOD 10
            Game(CurP).CurLv = Game(CurP).Lv
            PrintLv CurP
            Game(CurP).LeftKeyBuf = Game(CurP).LeftKeyBuf - 1
          END IF
          IF Game(CurP).RightKeyBuf THEN
            Game(CurP).Diff = (Game(CurP).Diff + 1) MOD 4
            'ClShowHigh CurP
            PrintDiff CurP
            Game(CurP).RightKeyBuf = Game(CurP).RightKeyBuf - 1
          END IF
          IF Game(CurP).RotateBuf THEN
            'ClShowHigh CurP
            GenJewel CurP
            FOR i = 0 TO 2
              Game(CurP).Cur(i) = Game(CurP).NextJewel(i)
            NEXT i
            Game(CurP).NextOK = False
            Game(CurP).CurX = 3
            Game(CurP).CurY = 12
            Game(CurP).TimeWait = Times(Game(CurP).CurLv)
            Game(CurP).Action = Moving
            Game(CurP).RotateBuf = Game(CurP).RotateBuf - 1
            Game(CurP).DropBuf = 0
          END IF
          IF Game(CurP).DropBuf THEN
            'ShowHigh CurP
            Game(CurP).DropBuf = Game(CurP).DropBuf - 1
          END IF

        CASE Moving
          IF Game(CurP).LeftKeyBuf > 0 AND NOT Game(CurP).Dropping THEN
            MvLeft CurP
            Game(CurP).LeftKeyWait = 4
            Game(CurP).LeftKeyBuf = Game(CurP).LeftKeyBuf - 1
          END IF
          IF Game(CurP).RightKeyBuf > 0 AND NOT Game(CurP).Dropping THEN
            MvRight CurP
            Game(CurP).RightKeyWait = 4
            Game(CurP).RightKeyBuf = Game(CurP).RightKeyBuf - 1
          END IF
          IF Game(CurP).RotateBuf > 0 AND NOT Game(CurP).Dropping THEN
            RotateJewel CurP
            Game(CurP).RotateBuf = Game(CurP).RotateBuf - 1
          END IF

          IF Game(CurP).LeftKey AND Game(CurP).LeftKeyWait = 0 AND NOT Game(CurP).RightKey AND Tick THEN
            IF NOT Game(CurP).Dropping THEN MvLeft CurP
          END IF
          IF Game(CurP).RightKey AND Game(CurP).RightKeyWait = 0 AND NOT Game(CurP).LeftKey AND Tick THEN
            IF NOT Game(CurP).Dropping THEN MvRight CurP
          END IF

          IF Game(CurP).DropBuf > 0 AND Game(CurP).LeftKeyBuf = 0 AND Game(CurP).RightKeyBuf = 0 AND Game(CurP).RotateBuf = 0 THEN
            Game(CurP).Score = Game(CurP).Score + (Game(CurP).CurLv + 1) * MvDrop(CurP)
            Game(CurP).DropBuf = Game(CurP).DropBuf - 1
          END IF

          IF Game(CurP).TimeWait = 0 OR Game(CurP).Dropping AND Tick THEN
            IF MvDown(CurP) THEN
              IF Game(CurP).CurY = 9 THEN GenJewel CurP
            ELSE
              IF Game(CurP).Dropping THEN PrintScore CurP
              Game(CurP).Dropping = False
              IF Game(CurP).Cur(0) = 7 THEN
                FOR i = 0 TO 2
                  Game(CurP).Board(Game(CurP).CurX, Game(CurP).CurY + i) = 15
                NEXT i
                Game(CurP).Top(Game(CurP).CurX) = Game(CurP).Top(Game(CurP).CurX) + 3
                Game(CurP).Action = Eating2
              ELSE
                FOR i = 0 TO 2
                  Game(CurP).Board(Game(CurP).CurX, Game(CurP).CurY + i) = Game(CurP).Cur(i)
                NEXT i
                Game(CurP).Top(Game(CurP).CurX) = Game(CurP).Top(Game(CurP).CurX) + 3
                Game(CurP).Action = Eating
              END IF
            END IF
            Game(CurP).TimeWait = Times(Game(CurP).CurLv)
          END IF

        CASE Eating
          Count = 0
          yInc = -1
          xInc = 1
          DO
            FOR y = -2 * (yInc = -1) TO 12
              FOR x = 0 TO 5 - 2 * xInc
                a = Game(CurP).Board(x, y) AND 7
                IF a <> 0 AND a = (Game(CurP).Board(x + xInc, y + yInc) AND 7) AND a = (Game(CurP).Board(x + 2 * xInc, y + 2 * yInc) AND 7) THEN
                  FOR i = 0 TO 2
                    Game(CurP).Board(x + i * xInc, y + i * yInc) = Game(CurP).Board(x + i * xInc, y + i * yInc) OR 8
                  NEXT i
                  Count = Count + 1
                END IF
              NEXT x
            NEXT y
            xInc = xInc + 1
            IF xInc = 2 THEN xInc = 0: yInc = yInc + 1
            IF yInc = 0 THEN xInc = 1
          LOOP UNTIL yInc = 2
          IF Count THEN
            Game(CurP).Score = Game(CurP).Score + Count * 30 * (Game(CurP).CurLv + 1) * Game(CurP).Chains
            Game(CurP).Chains = Game(CurP).Chains + 1
            Game(CurP).TimeWait = 5
            Game(CurP).Action = Marking
          ELSE
            IF Game(CurP).Jewels \ 50 > Game(CurP).CurLv AND Game(CurP).CurLv < 9 THEN
              Game(CurP).CurLv = Game(CurP).Jewels \ 50
              PrintLv CurP
            END IF
            IF NOT Game(CurP).NextOK THEN GenJewel CurP
            Game(CurP).NextOK = False
            Game(CurP).Chains = 1
            Game(CurP).CurX = 3
            Game(CurP).CurY = 12
            Game(CurP).TimeWait = Times(Game(CurP).CurLv)
            Game(CurP).Action = Moving

            FOR i = 0 TO 5
              IF Game(CurP).Top(i) > 12 THEN
                Game(CurP).Action = GameOver
                Game(CurP).TimeWait = 16
                EXIT FOR
              END IF
            NEXT i
            FOR i = 0 TO 2
              Game(CurP).Cur(i) = Game(CurP).NextJewel(i)
            NEXT i
          END IF

        CASE Eating2
          IF Game(CurP).CurY > 0 THEN
            Count = 0
            a = Game(CurP).Board(Game(CurP).CurX, Game(CurP).CurY - 1)
            FOR y = 0 TO 11
              FOR x = 0 TO 5
                IF Game(CurP).Board(x, y) = a THEN
                  Game(CurP).Board(x, y) = a OR 8
                  Count = Count + 1
                END IF
              NEXT x
            NEXT y
            Game(CurP).Score = Game(CurP).Score + Count * 10 * Game(CurP).CurLv
          END IF
          Game(CurP).Chains = 2
          Game(CurP).TimeWait = 5
          Game(CurP).Action = Marking

        CASE Marking
          IF Tick THEN
            FOR x = 0 TO 5
              FOR y = 0 TO Game(CurP).Top(x) - 1
                IF y = 12 THEN EXIT FOR
                IF Game(CurP).Board(x, y) AND 8 THEN
                  IF Game(CurP).TimeWait AND 1 THEN
                    ShowJewel CurP, x, y, Game(CurP).Board(x, y) AND 7
                  ELSE
                    ShowJewel CurP, x, y, 0
                  END IF
                END IF
              NEXT y
            NEXT x
            IF Game(CurP).TimeWait = 0 THEN
              Game(CurP).TimeWait = 5
              Game(CurP).Action = Clearing
            END IF
          END IF

        CASE Clearing
          IF Tick THEN
            IF Game(CurP).TimeWait THEN
              FOR x = 0 TO 5
                FOR y = 0 TO Game(CurP).Top(x) - 1
                  IF (Game(CurP).Board(x, y) AND 8) <> 0 AND y < 12 THEN
                    ShowJewel CurP, x, y, 12 - Game(CurP).TimeWait
                  END IF
                NEXT y
              NEXT x
            ELSE
              FOR x = 0 TO 5
                FOR y = 0 TO Game(CurP).Top(x) - 1
                  IF Game(CurP).Board(x, y) AND 8 THEN
                    IF y < 12 THEN ShowJewel CurP, x, y, 0
                    Game(CurP).Board(x, y) = 0
                    Game(CurP).Jewels = Game(CurP).Jewels + 1
                  END IF
                NEXT y
              NEXT x
              PrintScore CurP
              PrintJewels CurP
              Game(CurP).Action = Sinking
            END IF
          END IF

        CASE Sinking
          IF Tick THEN
            Sink = False
            FOR x = 0 TO 5
              DO WHILE Game(CurP).Top(x) > 0
                IF Game(CurP).Board(x, Game(CurP).Top(x) - 1) <> 0 THEN EXIT DO
                Game(CurP).Top(x) = Game(CurP).Top(x) - 1
              LOOP
              y = 0
              WHILE y < Game(CurP).Top(x) AND Game(CurP).Board(x, y) <> 0
                y = y + 1
              WEND
              IF y < Game(CurP).Top(x) THEN
                Game(CurP).Top(x) = Game(CurP).Top(x) - 1
                WHILE y < Game(CurP).Top(x)
                  IF Game(CurP).Board(x, y) <> Game(CurP).Board(x, y + 1) THEN
                    Game(CurP).Board(x, y) = Game(CurP).Board(x, y + 1)
                    IF y < 12 THEN ShowJewel CurP, x, y, Game(CurP).Board(x, y)
                    Sink = True
                  END IF
                  y = y + 1
                WEND
                Game(CurP).Board(x, y) = 0
                IF y < 12 THEN ShowJewel CurP, x, y, 0
              END IF
            NEXT x
            IF NOT Sink THEN Game(CurP).Action = Eating
          END IF

        CASE GameOver
          IF Tick THEN
            FOR x = 0 TO 5
              IF Game(CurP).TimeWait > 3 THEN ShowJewel CurP, x, 15 - Game(CurP).TimeWait, 8
              IF Game(CurP).TimeWait > 2 AND Game(CurP).TimeWait < 15 THEN ShowJewel CurP, x, 14 - Game(CurP).TimeWait, 9
              IF Game(CurP).TimeWait > 1 AND Game(CurP).TimeWait < 14 THEN ShowJewel CurP, x, 13 - Game(CurP).TimeWait, 10
              IF Game(CurP).TimeWait > 0 AND Game(CurP).TimeWait < 13 THEN ShowJewel CurP, x, 12 - Game(CurP).TimeWait, 11
              IF Game(CurP).TimeWait < 12 THEN ShowJewel CurP, x, 11 - Game(CurP).TimeWait, 0
            NEXT x
            IF Game(CurP).TimeWait = 0 THEN
              Game(CurP).Place = 11
              DO WHILE Game(CurP).Score > High.Score(Game(CurP).Place - 1, Game(CurP).Diff)
                Game(CurP).Place = Game(CurP).Place - 1
                IF Game(CurP).Place = 1 THEN EXIT DO
              LOOP
              IF Game(CurP).Diff = Game(1 - CurP).Diff THEN
                IF Game(CurP).Score < Game(1 - CurP).Score THEN
                  Game(CurP).Place = Game(CurP).Place + 1
                  IF Game(CurP).Place = 11 THEN
                    NewRecord Game(CurP).Diff, Game(CurP).Ini, Game(CurP).Score, Game(CurP).Jewels
                  END IF
                END IF
              END IF
              IF Game(CurP).Place <= 10 THEN
                Game(CurP).Action = HighMsg
                Game(CurP).PlaceStatus = 9
                IF Game(CurP).Diff = Game(1 - CurP).Diff THEN
                  IF Game(CurP).Score < Game(1 - CurP).Score THEN
                    Game(CurP).PlaceStatus = 13
                  END IF
                END IF
              ELSE
                Game(CurP).Action = GameOverMsg
              END IF
            END IF
            ClearBuf CurP
          END IF

        CASE HighMsg
          HighMessage CurP
          Game(CurP).Action = EnterName

        CASE EnterName
          IF Game(CurP).LeftKeyBuf THEN
            NameLeft CurP
            Game(CurP).LeftKeyBuf = Game(CurP).LeftKeyBuf - 1
          END IF
          IF Game(CurP).RightKeyBuf THEN
            NameRight CurP
            Game(CurP).RightKeyBuf = Game(CurP).RightKeyBuf - 1
          END IF
          IF Game(CurP).RotateBuf THEN
            NameUp CurP
            Game(CurP).RotateWait = 4
            Game(CurP).RotateBuf = Game(CurP).RotateBuf - 1
          END IF
          IF Game(CurP).DropBuf THEN
            NameDown CurP
            Game(CurP).DropWait = 4
            Game(CurP).DropBuf = Game(CurP).DropBuf - 1
          END IF
              
          IF Game(CurP).Rotate AND Game(CurP).RotateWait = 0 AND NOT Game(CurP).Drop AND Tick THEN
            NameUp CurP
          END IF
          IF Game(CurP).Drop AND Game(CurP).DropWait = 0 AND NOT Game(CurP).Rotate AND Tick THEN
            NameDown CurP
          END IF

          IF Game(CurP).Diff = Game(1 - CurP).Diff AND (Game(CurP).PlaceStatus AND 4) = 0 THEN
            IF Game(CurP).Score < Game(1 - CurP).Score THEN
              Game(CurP).PlaceStatus = Game(CurP).PlaceStatus OR 4
              Game(CurP).Place = Game(CurP).Place + 1
              IF Game(CurP).Place = 11 THEN
                NewRecord Game(CurP).Diff, Game(CurP).Ini, Game(CurP).Score, Game(CurP).Jewels
                Game(CurP).Action = OutMsg
              ELSE
                HighMessage CurP
              END IF
            END IF
          END IF

        CASE OutMsg
          NewRecord Game(CurP).Diff, Game(CurP).Ini, Game(CurP).Score, Game(CurP).Jewels
          Game(CurP).PlaceStatus = Game(CurP).PlaceStatus AND 4 + 16
          OutMessage CurP
          Game(CurP).TimeWait = 90
          Game(CurP).Action = ResetDelay

        CASE GameOverMsg
          GameOverMessage CurP
          Game(CurP).TimeWait = 90
          Game(CurP).Action = ResetDelay

        CASE ResetDelay
          IF Game(CurP).TimeWait = 0 THEN
            'ClGOverMes CurP
            ClearNext CurP
            ClearPlayer CurP
            ClearBuf CurP
            Game(CurP).Action = Selecting
          END IF

      END SELECT
    NEXT CurP
  LOOP UNTIL Finished
END SUB

FUNCTION MvDown (BYVAL Player)

  IF Game(Player).CurY = 0 THEN EXIT FUNCTION
  IF Game(Player).Top(Game(Player).CurX) >= Game(Player).CurY THEN EXIT FUNCTION
  IF Game(Player).Board(Game(Player).CurX, Game(Player).CurY - 1) THEN EXIT FUNCTION
  Game(Player).CurY = Game(Player).CurY - 1
  IF Game(Player).CurY < 9 THEN
    ShowJewel Player, Game(Player).CurX, 3 + Game(Player).CurY, 0
  END IF
  FOR i = 0 TO 2
    IF i + Game(Player).CurY < 12 THEN
      ShowJewel Player, Game(Player).CurX, i + Game(Player).CurY, Game(Player).Cur(i)
    END IF
  NEXT i
  MvDown = True

END FUNCTION

FUNCTION MvDrop (BYVAL Player)

  IF NOT Game(Player).Dropping THEN
    MvDrop = Game(Player).CurY - Game(Player).Top(Game(Player).CurX)
    Game(Player).Dropping = True
  END IF

END FUNCTION

SUB MvLeft (BYVAL Player)
  IF Game(Player).CurX = 0 THEN EXIT SUB
  IF Game(Player).Top(Game(Player).CurX - 1) > Game(Player).CurY THEN EXIT SUB
  FOR i = 0 TO 2
    IF i + Game(Player).CurY < 12 THEN
      ShowJewel Player, Game(Player).CurX, i + Game(Player).CurY, 0
    END IF
  NEXT i
  Game(Player).CurX = Game(Player).CurX - 1
  FOR i = 0 TO 2
    IF i + Game(Player).CurY < 12 THEN
      ShowJewel Player, Game(Player).CurX, i + Game(Player).CurY, Game(Player).Cur(i)
    END IF
  NEXT i
END SUB

SUB MvRight (BYVAL Player)
  IF Game(Player).CurX = 5 THEN EXIT SUB
  IF Game(Player).Top(Game(Player).CurX + 1) > Game(Player).CurY THEN EXIT SUB
  FOR i = 0 TO 2
    IF i + Game(Player).CurY < 12 THEN
      ShowJewel Player, Game(Player).CurX, i + Game(Player).CurY, 0
    END IF
  NEXT i
  Game(Player).CurX = Game(Player).CurX + 1
  FOR i = 0 TO 2
    IF i + Game(Player).CurY < 12 THEN
      ShowJewel Player, Game(Player).CurX, i + Game(Player).CurY, Game(Player).Cur(i)
    END IF
  NEXT i
END SUB

SUB NameDown (BYVAL Player)
  a = INSTR(NameStr, MID$(Game(Player).Ini, Game(Player).PlaceStatus AND 3, 1))
  a = (a + LEN(NameStr) - 2) MOD LEN(NameStr) + 1
  MID$(Game(Player).Ini, Game(Player).PlaceStatus AND 3, 1) = MID$(NameStr, a, 1)
  ShowName Player, Game(Player).PlaceStatus AND 3, True
END SUB

SUB NameLeft (BYVAL Player)
  IF (Game(Player).PlaceStatus AND 3) > 1 THEN
    ShowName Player, Game(Player).PlaceStatus AND 3, False
    Game(Player).PlaceStatus = Game(Player).PlaceStatus - 1
    ShowName Player, Game(Player).PlaceStatus AND 3, True
  END IF
END SUB

SUB NameRight (BYVAL Player)
  IF (Game(Player).PlaceStatus AND 3) < 3 THEN
    ShowName Player, Game(Player).PlaceStatus AND 3, False
    Game(Player).PlaceStatus = Game(Player).PlaceStatus + 1
    ShowName Player, Game(Player).PlaceStatus AND 3, True
  ELSE
    NewRecord Game(Player).Diff, Game(Player).Ini, Game(Player).Score, Game(Player).Jewels
    Game(Player).PlaceStatus = (Game(Player).PlaceStatus AND 4) + 16
    FOR y = 5 TO 8
      FOR x = 1 TO 4
        ShowJewel Player, x, y, 0
      NEXT x
    NEXT y
    Game(Player).Action = GameOverMsg
  END IF
END SUB

SUB NameUp (BYVAL Player)
  a = INSTR(NameStr, MID$(Game(Player).Ini, Game(Player).PlaceStatus AND 3, 1))
  a = a MOD LEN(NameStr) + 1
  MID$(Game(Player).Ini, Game(Player).PlaceStatus AND 3, 1) = MID$(NameStr, a, 1)
  ShowName Player, Game(Player).PlaceStatus AND 3, True
END SUB

SUB NewRecord (Diff, Ini AS STRING, Score AS LONG, Jewels AS LONG)
  IF Score > High.Score(10, Diff) THEN
    i = 10
    DO WHILE Score > High.Score(i - 1, Diff)
      High.Score(i, Diff) = High.Score(i - 1, Diff)
      High.Ini(i, Diff) = High.Ini(i - 1, Diff)
      High.Jewels(i, Diff) = High.Jewels(i - 1, Diff)
      i = i - 1
      IF i = 1 THEN EXIT DO
    LOOP
    High.Score(i, Diff) = Score
    High.Ini(i, Diff) = Ini
    High.Jewels(i, Diff) = Jewels
  END IF
END SUB

SUB ReadTop ()
  OPEN "High.dat" FOR BINARY AS #1
  GET #1, , High
  CLOSE #1
END SUB

SUB RotateJewel (BYVAL Player)
  temp = Game(Player).Cur(0)
  Game(Player).Cur(0) = Game(Player).Cur(1)
  Game(Player).Cur(1) = Game(Player).Cur(2)
  Game(Player).Cur(2) = temp
  FOR i = 0 TO 2
    IF i + Game(Player).CurY < 12 THEN
      ShowJewel Player, Game(Player).CurX, i + Game(Player).CurY, Game(Player).Cur(i)
    END IF
  NEXT i
END SUB

SUB UpDateTop ()
  OPEN "High.dat" FOR BINARY AS #1
  PUT #1, , High
  CLOSE #1
END SUB

