TYPE GameData
  Board(5, 14) AS INTEGER
  Top(5)  AS INTEGER
  Cur(2) AS INTEGER
  CurX AS INTEGER
  CurY AS INTEGER
  Dropping AS INTEGER
  NextJewel(2) AS INTEGER
  NextOK AS INTEGER
  Action AS INTEGER
  Lv AS INTEGER
  CurLv AS INTEGER
  TimeWait AS INTEGER    ' to delay action e.g. move jewel downward
  Diff AS INTEGER
  Jewels AS LONG
  TilesPlayed AS LONG
  Score AS LONG
  Chains AS INTEGER      ' multiplier of score in chains
  LeftKey AS INTEGER     ' Key States
  LeftKeyWait AS INTEGER ' Time to wait for response
  RightKey AS INTEGER
  RightKeyWait AS INTEGER
  Rotate AS INTEGER      ' Rotate does not affect block continuously
  RotateWait AS INTEGER  ' Used in entering names
  Drop AS INTEGER        ' Drop also
  DropWait AS INTEGER    ' Used in entering names
  LeftKeyBuf AS INTEGER  ' Key Buffer
  RightKeyBuf AS INTEGER ' Wait for response for at least once
  RotateBuf AS INTEGER
  DropBuf AS INTEGER
  Ini AS STRING * 3      ' Name for high scores
  Place AS LONG          ' Place for high scores
  PlaceStatus AS INTEGER
END TYPE

TYPE Top10
  Ini(1 TO 10, 0 TO 3) AS STRING * 3
  Score(1 TO 10, 0 TO 3) AS LONG
  Jewels(1 TO 10, 0 TO 3) AS LONG
END TYPE

CONST True = -1, False = NOT True
CONST NameStr = " ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-."

COMMON SHARED Game() AS GameData, High AS Top10

