VERSION 4.00
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Form1"
   ClientHeight    =   4200
   ClientLeft      =   870
   ClientTop       =   2610
   ClientWidth     =   8520
   Height          =   4605
   Left            =   810
   LinkTopic       =   "Form1"
   ScaleHeight     =   280
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   568
   Top             =   2265
   Width           =   8640
   Begin VB.PictureBox PalCol 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3840
      Left            =   3240
      ScaleHeight     =   256
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   256
      TabIndex        =   2
      Top             =   120
      Width           =   3840
   End
   Begin VB.CommandButton SaveBtn 
      Caption         =   "&Save"
      Height          =   495
      Left            =   7200
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB.ListBox PalList 
      Height          =   3930
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit
DefByte A-Z
Dim Pal&(255)
Const p$ = "f:\kolumns\sv_graph\"
Const S1$ = p$ + "columns.pal"
Const S2$ = p$ + "colpal.bak"
Private Sub Form_Activate()
  Dim i As Integer
  Open S1$ For Binary Access Read As #1
  i = 0
  Get #1, , Pal&(i)
  While Not EOF(1)
    PalCol.Line ((i And 15) * 16, i And 240)-Step(15, 15), Pal&(i), BF
    If Pal&(i) Mod 4 <> 0 Or Pal&(i) \ 256 Mod 4 <> 0 Or _
       Pal&(i) \ 65536 Mod 4 <> 0 Then _
       PalList.AddItem Str$(i) + Chr$(9) + Str$(Pal&(i))
    i = i + 1
    Get #1, , Pal&(i)
  Wend
  Close #1
  If PalList.ListCount = 0 Then
    For i = 0 To i - 1
      PalList.AddItem Str$(i) + Chr$(9) + Str$(Pal&(i) Mod 256) + Chr$(9) _
        + Str$(Pal&(i) \ 256 Mod 256) + Chr$(9) + Str$(Pal&(i) \ 65536 Mod 256)
    Next i
  End If
  PalList.ListIndex = 0
End Sub

Private Sub PalCol_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  Dim i
  i = X \ 16 + (Y \ 16) * 16
  If i < PalList.ListCount Then PalList.ListIndex = i
  PalList.SetFocus
End Sub

Private Sub PalList_KeyPress(KeyAscii As Integer)
  Dim s$, i, a&
  i = PalList.ListIndex
  Select Case KeyAscii
    Case 56, 52
      If i > 0 Then
        s$ = PalList.List(i)
        PalList.ListIndex = i - 1
        PalList.List(i) = PalList.List(i - 1)
        PalList.List(i - 1) = s$
        a& = Pal(i): Pal(i) = Pal(i - 1): Pal(i - 1) = a&
        PalCol.Line ((i And 15) * 16, i And 240)-Step(15, 15), Pal&(i), BF
        PalCol.Line ((i - 1 And 15) * 16, i - 1 And 240)-Step(15, 15), Pal&(i - 1), BF
      End If
    Case 54, 50
      If i < PalList.ListCount - 1 Then
        s$ = PalList.List(i)
        PalList.ListIndex = i + 1
        PalList.List(i) = PalList.List(i + 1)
        PalList.List(i + 1) = s$
        a& = Pal(i): Pal(i) = Pal(i + 1): Pal(i + 1) = a&
        PalCol.Line ((i And 15) * 16, i And 240)-Step(15, 15), Pal&(i), BF
        PalCol.Line ((i + 1 And 15) * 16, i + 1 And 240)-Step(15, 15), Pal&(i + 1), BF
      End If
  End Select
End Sub

Private Sub SaveBtn_Click()
  Dim i
  If MsgBox("Save palette ?", vbYesNo + vbQuestion) = vbYes Then
    If Dir(S2$) <> "" Then Kill S2$
    Open S1$ For Binary Access Write As #1
    Open S2$ For Binary Access Write As #2
    For i = 0 To PalList.ListCount - 1
      Put #1, , Pal(i)
      Put #2, , Pal(i)
    Next i
    Reset
  End If
End Sub

